/*
 * AutoSessioneServlet.java
 *
 * Created on 16 luglio 2004, 19.27
 */

package sessionHandling;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;

/**
 *
 * @author  gdestri
 * @version
 */
public class AutoSessioneServlet extends HttpServlet {

    // attributo di servizio (Autenticatore)
    Autenticatore auto = new Autenticatore();
    
    /** Initializes the servlet.
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        
    }
    
    /** Destroys the servlet.
     */
    public void destroy() {
        
    }
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        
        // definisce la URL dell'errore
        String URL_errato = "/EsempiWebIS2005/sessione/sbagliato.html";
        
          // riceve i parametri dalla form HTML
        String usernameString = request.getParameter("usernameText");
        String passwordString = request.getParameter("passwordText");
        boolean res = false;
        String risposta;
        if ((usernameString != null) && (passwordString != null)) {
            res = auto.checkUsernameAndPassword(usernameString, passwordString);               
        }
        if (res == true) {        
            // abilita l'uso della sessione
            HttpSession session = request.getSession(true);

            // registra il timestamp della creazione della sessione
            Date created = new Date(session.getCreationTime());
            Date accessed = new Date(session.getLastAccessedTime());
        
            // crea un utenteWeb
            UtenteWeb currentUser = new UtenteWeb(usernameString, 
                                                  created.toString(), 
                                                  accessed.toString(), 
                                                  session.getId());

            // lo aggancia alla sessione
            session.setAttribute("utenteCorrente", currentUser);
            
            // ridirige l'output sulla pagina giusto.jsp
            request.getRequestDispatcher("sessione/giusto.jsp").forward(request, response);
            
            
//            response.setContentType("text/html");
//            PrintWriter out = response.getWriter();
//
//                
//        //TODO output your page here
//        out.println("<html>");
//        out.println("<head>");
//        out.println("<title>Servlet</title>");
//        out.println("</head>");
//        out.println("<body>");
//        
//            out.println(currentUser.toString());
//
//        
//        out.println("</body>");
//        out.println("</html>");
//         
//            out.close();
        } // end if
        else {
            response.sendRedirect(URL_errato);
        }
    }
    
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    
} // end class AutoSessioneServlet
